webpackJsonp([0],{

/***/ 116:
/***/ (function(module, exports) {

function webpackEmptyAsyncContext(req) {
	// Here Promise.resolve().then() is used instead of new Promise() to prevent
	// uncatched exception popping up in devtools
	return Promise.resolve().then(function() {
		throw new Error("Cannot find module '" + req + "'.");
	});
}
webpackEmptyAsyncContext.keys = function() { return []; };
webpackEmptyAsyncContext.resolve = webpackEmptyAsyncContext;
module.exports = webpackEmptyAsyncContext;
webpackEmptyAsyncContext.id = 116;

/***/ }),

/***/ 157:
/***/ (function(module, exports) {

function webpackEmptyAsyncContext(req) {
	// Here Promise.resolve().then() is used instead of new Promise() to prevent
	// uncatched exception popping up in devtools
	return Promise.resolve().then(function() {
		throw new Error("Cannot find module '" + req + "'.");
	});
}
webpackEmptyAsyncContext.keys = function() { return []; };
webpackEmptyAsyncContext.resolve = webpackEmptyAsyncContext;
module.exports = webpackEmptyAsyncContext;
webpackEmptyAsyncContext.id = 157;

/***/ }),

/***/ 18:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return StoreService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_BehaviorSubject__ = __webpack_require__(281);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_rxjs_BehaviorSubject___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_rxjs_BehaviorSubject__);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};


var StoreService = /** @class */ (function () {
    function StoreService() {
        this.dbOpenedSubject = new __WEBPACK_IMPORTED_MODULE_1_rxjs_BehaviorSubject__["BehaviorSubject"](false);
        this.coinsSubject = new __WEBPACK_IMPORTED_MODULE_1_rxjs_BehaviorSubject__["BehaviorSubject"](0);
        this._isSoundOn = true;
        this._totalComposingWordsCount = 0;
        this._allOpenedWordsCount = 0;
    }
    StoreService.prototype.isDBOpened = function () {
        return this.dbOpenedSubject.asObservable();
    };
    StoreService.prototype.openDB = function (isOpened) {
        this.dbOpenedSubject.next(isOpened);
    };
    StoreService.prototype.getCoins = function () {
        return this.coinsSubject.asObservable();
    };
    StoreService.prototype.addCoins = function (amount) {
        this.coinsSubject.next(this.coinsSubject.value + amount);
    };
    Object.defineProperty(StoreService.prototype, "isSoundOn", {
        get: function () {
            return this._isSoundOn;
        },
        set: function (isOn) {
            this._isSoundOn = isOn;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StoreService.prototype, "theme", {
        get: function () {
            return this._theme;
        },
        set: function (theme) {
            this._theme = theme;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StoreService.prototype, "totalComposingWordsCount", {
        get: function () {
            return this._totalComposingWordsCount;
        },
        set: function (count) {
            this._totalComposingWordsCount = count;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StoreService.prototype, "allOpenedWordsCount", {
        get: function () {
            return this._allOpenedWordsCount;
        },
        set: function (count) {
            this._allOpenedWordsCount = count;
        },
        enumerable: true,
        configurable: true
    });
    StoreService = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["A" /* Injectable */])()
    ], StoreService);
    return StoreService;
}());

//# sourceMappingURL=store.js.map

/***/ }),

/***/ 200:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HomePage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_animations__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ionic_angular__ = __webpack_require__(29);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__services_db__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__services_store__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__services_achievements__ = __webpack_require__(38);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__services_utils__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__word_word__ = __webpack_require__(201);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};








var HomePage = /** @class */ (function () {
    function HomePage(cdr, navCtrl, platform, dbService, storeService, achievementsService, utilsService) {
        this.cdr = cdr;
        this.navCtrl = navCtrl;
        this.platform = platform;
        this.dbService = dbService;
        this.storeService = storeService;
        this.achievementsService = achievementsService;
        this.utilsService = utilsService;
        this.categories = [];
        this.words = [];
        this.openedCategoriesCount = 0;
        this.openedCategoriesTotalComposingWordsCount = 0;
        this.remainingComposingWordsCountToOpenCategory = 0;
        this.isDataLoaded = false;
        this.coins$ = this.storeService.getCoins();
        this.manageData();
    }
    HomePage.prototype.ionViewDidEnter = function () {
        this.setRemainingComposingWordsCount();
        this.openCategoryIfNeeded();
    };
    HomePage.prototype.toggleCategory = function (category) {
        if (category.isOpened) {
            this.shownCategory = this.isCategoryShown(category) ? null : category;
            this.cdr.detectChanges();
        }
    };
    ;
    HomePage.prototype.isCategoryShown = function (category) {
        return this.shownCategory === category;
    };
    HomePage.prototype.trackCategory = function (index, category) {
        return category.id;
    };
    HomePage.prototype.getWordsCountTextByTotalCategoryCount = function (category) {
        if ((category.totalComposingWordsCount.toString().slice(-1) === '1') &&
            (category.totalComposingWordsCount.toString().slice(-2) !== '11')) {
            return 'слова';
        }
        return 'слів';
    };
    HomePage.prototype.getWordsCountTextByRemainingCount = function () {
        var wordText = '';
        var numberToCheck = this.remainingComposingWordsCountToOpenCategory % 100;
        if ((numberToCheck >= 5 && numberToCheck <= 20)) {
            wordText = 'слів';
        }
        else
            switch (this.remainingComposingWordsCountToOpenCategory % 10) {
                case 1:
                    wordText = 'слово';
                    break;
                case 2:
                case 3:
                case 4:
                    wordText = 'слова';
                    break;
                default:
                    wordText = 'слів';
                    break;
            }
        return wordText;
    };
    HomePage.prototype.onWordClick = function (word, category) {
        this.navCtrl.push(__WEBPACK_IMPORTED_MODULE_7__word_word__["a" /* WordPage */], { word: word, category: category });
    };
    HomePage.prototype.manageData = function () {
        var _this = this;
        this.storeService.isDBOpened().subscribe(function (isDBOpened) {
            if (isDBOpened) {
                _this.dbService.executeQuery(__WEBPACK_IMPORTED_MODULE_3__services_db__["a" /* DBQueries */].GET_CATEGORIES, function (tr, rs) {
                    _this.setCategories(rs.rows);
                    _this.dbService.executeQuery(__WEBPACK_IMPORTED_MODULE_3__services_db__["a" /* DBQueries */].GET_WORDS, function (tr, rs) {
                        _this.setWords(rs.rows);
                        _this.isDataLoaded = true;
                        _this.cdr.detectChanges();
                    });
                });
            }
            else {
                _this.isDataLoaded = true;
            }
        });
    };
    HomePage.prototype.setCategories = function (rows) {
        for (var i = 0; i < rows.length; i++) {
            this.categories.push(rows.item(i));
        }
        for (var i = 0; i < this.categories.length; i++) {
            if (this.categories[i].isOpened === 0) {
                this.firstClosedCategory = this.categories[i];
                this.firstClosedCategory.index = i;
                break;
            }
        }
    };
    HomePage.prototype.setWords = function (rows) {
        this.words = [];
        for (var i = 0; i < rows.length; i++) {
            this.words.push(rows.item(i));
        }
        this.setCategoriesToDisplay();
        this.setRemainingComposingWordsCount();
        this.openCategoryIfNeeded();
    };
    HomePage.prototype.setCategoriesToDisplay = function () {
        this.storeService.totalComposingWordsCount = 0;
        this.storeService.allOpenedWordsCount = 0;
        this.categoriesToDisplay = [];
        this.openedCategoriesCount = 0;
        this.openedCategoriesTotalComposingWordsCount = 0;
        for (var i = 0; i < this.categories.length; i++) {
            var category = this.categories[i];
            if (category.isOpened) {
                this.openedCategoriesCount++;
            }
            this.prepareCategoryToDisplay(category);
            this.categoriesToDisplay.push(category);
        }
    };
    HomePage.prototype.prepareCategoryToDisplay = function (category) {
        category.totalComposingWordsCount = 0;
        category.openedComposingWordsCount = 0;
        category.words = [];
        for (var i = 0; i < this.words.length; i++) {
            var word = this.words[i];
            if (word.categoryId == category.id) {
                category.words.push(word);
                category.totalComposingWordsCount += word.totalComposingWords;
                category.openedComposingWordsCount += word.openedComposingWords;
                this.storeService.totalComposingWordsCount += word.totalComposingWords;
                this.storeService.allOpenedWordsCount += word.openedComposingWords;
                if (category.isOpened) {
                    this.openedCategoriesTotalComposingWordsCount += word.totalComposingWords;
                }
            }
        }
    };
    HomePage.prototype.setRemainingComposingWordsCount = function () {
        var composingWordsCountToOpenCategory = Math.floor(this.openedCategoriesTotalComposingWordsCount * 0.5);
        this.remainingComposingWordsCountToOpenCategory = composingWordsCountToOpenCategory - this.storeService.allOpenedWordsCount;
    };
    HomePage.prototype.openCategoryIfNeeded = function () {
        if (this.remainingComposingWordsCountToOpenCategory <= 0 && this.firstClosedCategory) {
            this.openCategory();
            this.manageAhievements();
            this.utilsService.playSound('bonus');
            this.utilsService.showOpenedCategoryAlert(this.firstClosedCategory.name);
        }
    };
    HomePage.prototype.openCategory = function () {
        var _this = this;
        this.dbService.executeQuery(__WEBPACK_IMPORTED_MODULE_3__services_db__["a" /* DBQueries */].OPEN_CATEGORY_BY_ID, function (tr, rs) {
            _this.categories[_this.firstClosedCategory.index].isOpened = 1;
            _this.setCategoriesToDisplay();
            _this.setFirstClosedCategory();
            _this.setRemainingComposingWordsCount();
        }, [this.firstClosedCategory.id]);
    };
    HomePage.prototype.setFirstClosedCategory = function () {
        if (this.categoriesToDisplay) {
            for (var i = 0; i < this.categoriesToDisplay.length; i++) {
                if (this.categoriesToDisplay[i].isOpened === 0) {
                    this.firstClosedCategory = this.categoriesToDisplay[i];
                    this.firstClosedCategory.index = i;
                    break;
                }
            }
        }
    };
    HomePage.prototype.manageAhievements = function () {
        if (this.firstClosedCategory.id == 2) {
            this.achievementsService.manageAchievementByIndex(3);
        }
        if (this.firstClosedCategory.id == 10) {
            this.achievementsService.manageAchievementByIndex(4);
        }
    };
    HomePage = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["m" /* Component */])({
            selector: 'page-home',template:/*ion-inline-start:"D:\GIT\wordsInAWord\src\pages\home\home.html"*/'<ion-header>\n  <ion-navbar>\n    <button ion-button menuToggle>\n      <ion-icon name="menu"></ion-icon>\n    </button>\n    <ion-title>ГРАТИ</ion-title>\n  </ion-navbar>\n  <div class="border-decoration"></div>\n</ion-header>\n\n<ion-content class="categories-list">\n  <p *ngIf="categoriesToDisplay" class="categories-stats">\n    <ion-icon name="stats"></ion-icon> \n    Відкрито категорій {{openedCategoriesCount}}/{{categories.length}}\n  </p>\n\n  <ion-list *ngIf="categoriesToDisplay">\n    <div class="border-decoration"></div>\n    <div *ngFor="let category of categories; trackBy: trackCategory" [@easeIn]>\n      <ion-item class="item-stable category"\n                [class.active]="isCategoryShown(category)"\n                (click)="toggleCategory(category)">\n        <div class="category-info">\n          <h1>\n            <span *ngIf="category.isOpened">\n              <ion-icon *ngIf="!isCategoryShown(category)" name="add"></ion-icon>\n              <ion-icon *ngIf="isCategoryShown(category)" name="remove"></ion-icon>\n            </span>\n            <ion-icon *ngIf="!category.isOpened" name="lock"></ion-icon>\n            {{category.isOpened ? category.name : \'? ? ? ? ?\'}}\n          </h1>\n          <p *ngIf="category.isOpened"> \n            Складено {{category.openedComposingWordsCount}} з {{category.totalComposingWordsCount}} {{getWordsCountTextByTotalCategoryCount(category)}}\n          </p>\n          <p *ngIf="firstClosedCategory && category.id==firstClosedCategory.id">Складіть ще <span>{{remainingComposingWordsCountToOpenCategory}}</span>\n            {{getWordsCountTextByRemainingCount()}}, щоб відкрити</p>\n        </div>\n\n        <img class="category-icon" src="assets/img/categories/{{category.id}}.jpg">\n      </ion-item>\n\n      <div *ngIf="isCategoryShown(category)">\n        <div class="border-decoration"></div>\n        <div [@easeIn]>\n          <ion-item *ngFor="let word of category.words"\n                    class="item-accordion category-word"\n                    (click)="onWordClick(word, category)">\n            {{word.name}}\n            <p>{{word.openedComposingWords}} з {{word.totalComposingWords}}</p>\n          </ion-item>\n        </div>\n      </div>\n      <div class="border-decoration" ng-show="isCategoryShown(category)"></div>\n    </div>\n  </ion-list>\n</ion-content>\n\n<ion-footer class="footer">\n  <div class="border-decoration"></div>\n  <ion-toolbar>\n    <ion-title>\n      <span class="coins-info">\n        <span class="coins-button">{{coins$ | async}}</span>\n        <img class="coins-image" src="assets/img/gold_coins.png">\n      </span>\n    </ion-title>\n  </ion-toolbar>\n</ion-footer>\n'/*ion-inline-end:"D:\GIT\wordsInAWord\src\pages\home\home.html"*/,
            animations: [
                Object(__WEBPACK_IMPORTED_MODULE_1__angular_animations__["i" /* trigger */])('easeIn', [
                    Object(__WEBPACK_IMPORTED_MODULE_1__angular_animations__["h" /* transition */])(':enter', [
                        Object(__WEBPACK_IMPORTED_MODULE_1__angular_animations__["g" /* style */])({ opacity: 0 }),
                        Object(__WEBPACK_IMPORTED_MODULE_1__angular_animations__["e" /* animate */])('400ms ease-in', Object(__WEBPACK_IMPORTED_MODULE_1__angular_animations__["g" /* style */])({ opacity: 1 }))
                    ]),
                    Object(__WEBPACK_IMPORTED_MODULE_1__angular_animations__["h" /* transition */])(':leave', [
                        Object(__WEBPACK_IMPORTED_MODULE_1__angular_animations__["e" /* animate */])('400ms ease-in', Object(__WEBPACK_IMPORTED_MODULE_1__angular_animations__["g" /* style */])({ opacity: 0 }))
                    ])
                ])
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["j" /* ChangeDetectorRef */],
            __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["f" /* NavController */],
            __WEBPACK_IMPORTED_MODULE_2_ionic_angular__["h" /* Platform */],
            __WEBPACK_IMPORTED_MODULE_3__services_db__["b" /* DBService */],
            __WEBPACK_IMPORTED_MODULE_4__services_store__["a" /* StoreService */],
            __WEBPACK_IMPORTED_MODULE_5__services_achievements__["a" /* AchievementsService */],
            __WEBPACK_IMPORTED_MODULE_6__services_utils__["a" /* UtilsService */]])
    ], HomePage);
    return HomePage;
}());

//# sourceMappingURL=home.js.map

/***/ }),

/***/ 201:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return WordPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(29);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__services_db__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__services_store__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__services_achievements__ = __webpack_require__(38);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__services_utils__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__composing_word_composing_word__ = __webpack_require__(202);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};







var WordPage = /** @class */ (function () {
    function WordPage(navCtrl, navParams, elRef, cdr, dbService, storeService, achievementsService, utilsService) {
        this.navCtrl = navCtrl;
        this.navParams = navParams;
        this.elRef = elRef;
        this.cdr = cdr;
        this.dbService = dbService;
        this.storeService = storeService;
        this.achievementsService = achievementsService;
        this.utilsService = utilsService;
        this.composedWord = '';
        this.coins = 0;
        this.isCoinsEarned = false;
        this.isAlreadyOpenedWord = false;
        this.isDataLoaded = false;
        this.word = this.navParams.get('word');
        this.categoryInfo = this.navParams.get('category');
        this.displayName = this.word.name.replace('-', '');
        this.letters = this.displayName.split('');
        this.setCoins();
        this.setComposingWords();
    }
    WordPage.prototype.ionViewDidEnter = function () {
        this.resize();
    };
    Object.defineProperty(WordPage.prototype, "openedWordsCount", {
        get: function () {
            var count = 0;
            if (this.word && this.word.composingWords) {
                for (var i = 0; i < this.word.composingWords.length; i++) {
                    if (this.word.composingWords[i].isOpened == 1)
                        count += 1;
                }
            }
            return count;
        },
        enumerable: true,
        configurable: true
    });
    ;
    Object.defineProperty(WordPage.prototype, "endOfOpenedWordsDescription", {
        get: function () {
            if (this.word && this.word.composingWords) {
                if (this.word.composingWords.length.toString().slice(-2) == 11)
                    return 'слів';
                else if (this.word.composingWords.length % 10 == 1)
                    return 'слова';
                else
                    return 'слів';
            }
        },
        enumerable: true,
        configurable: true
    });
    ;
    WordPage.prototype.displayNotOpenedWord = function (wordLength) {
        var s = '-';
        for (var i = 0; i < wordLength - 1; i++) {
            s += ' -';
        }
        return s;
    };
    WordPage.prototype.onLettersClick = function (event) {
        var targetEl = event.target;
        if (targetEl.nodeName === 'BUTTON') {
            targetEl.setAttribute('disabled', 'disabled');
            targetEl.classList.add('word-name-button-disabled');
            this.setComposedWordValue(this.composedWord + targetEl.innerText);
            if (!this.isTimeAchievementEarned && this.composedWord.length === 1) {
                this.startComposeWordTime = new Date().getTime();
            }
            this.checkComposedWord();
        }
    };
    WordPage.prototype.onClearClick = function () {
        this.enableAllLetters();
        this.setComposedWordValue('');
    };
    WordPage.prototype.onLastLetterRemoveClick = function () {
        var lastLetter = this.composedWord.charAt(this.composedWord.length - 1);
        if (lastLetter) {
            this.enableSpecificLetter(lastLetter);
            this.setComposedWordValue(this.composedWord.slice(0, -1));
        }
    };
    WordPage.prototype.onComposingWordsClick = function (event) {
        for (var i = 0; i <= event.path.length; i++) {
            if (event.path[i].nodeName === 'ION-ITEM') {
                var composingWordIndex = event.path[i].getAttribute('data-index');
                this.navCtrl.push(__WEBPACK_IMPORTED_MODULE_6__composing_word_composing_word__["a" /* ComposingWordPage */], {
                    composingWord: this.word.composingWords[composingWordIndex],
                    word: this.word,
                    categoryInfo: this.categoryInfo,
                });
                break;
            }
        }
    };
    WordPage.prototype.trackComposingWord = function (index, composingWord) {
        return composingWord.id;
    };
    Object.defineProperty(WordPage.prototype, "isTimeAchievementEarned", {
        get: function () {
            return this.achievementsService.achievements[0].isEarned;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WordPage.prototype, "isLongestWordAchievementEarned", {
        get: function () {
            return this.achievementsService.achievements[1].isEarned;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WordPage.prototype, "isWordComposedAchievementEarned", {
        get: function () {
            return this.achievementsService.achievements[2].isEarned;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WordPage.prototype, "isCategoryComposedAchievementEarned", {
        get: function () {
            return this.achievementsService.achievements[5].isEarned;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WordPage.prototype, "isUniqueComposedWordsAchievementEarned", {
        get: function () {
            return this.achievementsService.achievements[6].isEarned;
        },
        enumerable: true,
        configurable: true
    });
    WordPage.prototype.resize = function () {
        var offset = this.headerTag.nativeElement.offsetHeight;
        this.scrollableTag.nativeElement.style.marginTop = offset + 'px';
    };
    WordPage.prototype.setCoins = function () {
        var _this = this;
        this.storeService.getCoins().subscribe(function (amount) {
            _this.coins = amount;
        });
    };
    WordPage.prototype.setComposingWords = function () {
        var _this = this;
        this.dbService.executeQuery(__WEBPACK_IMPORTED_MODULE_2__services_db__["a" /* DBQueries */].GET_COMPOSING_WORDS, function (tr, rs) {
            _this.word.totalComposingWords = rs.rows.length;
            _this.word.openedComposingWords = 0;
            var composingWords = [];
            for (var i = 0; i < rs.rows.length; i++) {
                var composingWord = rs.rows.item(i);
                composingWords.push(composingWord);
                if (composingWord.isOpened) {
                    _this.word.openedComposingWords++;
                }
            }
            _this.sortArrayByNameLength(composingWords, 'asc');
            _this.word.composingWords = composingWords;
            _this.isDataLoaded = true;
        }, [this.word.id]);
    };
    WordPage.prototype.sortArrayByNameLength = function (arr, orderDirection) {
        arr.sort(function (a, b) {
            if (orderDirection = 'asc')
                return a.name.length - b.name.length || a.name.localeCompare(b.name);
            if (orderDirection = 'desc')
                return b.name.length - a.name.length || b.name.localeCompare(a.name);
        });
    };
    WordPage.prototype.setComposedWordValue = function (text) {
        this.composedWord = text;
        this.composedWordEl.nativeElement.value = text;
    };
    WordPage.prototype.getAllLetters = function () {
        return this.elRef.nativeElement.getElementsByClassName('word-name-button');
    };
    WordPage.prototype.enableAllLetters = function () {
        var letters = this.getAllLetters();
        for (var i = letters.length - 1; i >= 0; i--) {
            if (letters[i].disabled) {
                this.enableLetter(letters[i]);
            }
        }
    };
    WordPage.prototype.enableSpecificLetter = function (letter) {
        var letters = this.getAllLetters();
        for (var i = letters.length - 1; i >= 0; i--) {
            if (letters[i].disabled && (letters[i].innerText === letter)) {
                this.enableLetter(letters[i]);
                break;
            }
        }
    };
    WordPage.prototype.enableLetter = function (letterEl) {
        letterEl.removeAttribute('disabled');
        letterEl.classList.remove('word-name-button-disabled');
    };
    WordPage.prototype.checkComposedWord = function () {
        var _this = this;
        var foundWord = this.word.composingWords.find(function (word) { return word.name === _this.composedWord; });
        if (foundWord) {
            if (foundWord.isOpened) {
                this.manageAlreadyOpenedWord(foundWord);
            }
            else {
                this.openedWord = foundWord.name;
                this.word.openedComposingWords++;
                this.categoryInfo.openedComposingWordsCount++;
                if (this.startComposeWordTime) {
                    this.manageComposeWordTime();
                }
                this.manageAchievements();
                this.manageCoins();
                this.setComposedWordValue('');
                this.enableAllLetters();
                this.openComposedWord(foundWord);
            }
        }
    };
    WordPage.prototype.manageAlreadyOpenedWord = function (composingWord) {
        var _this = this;
        this.utilsService.playSound('cancel');
        this.alreadyOpenedWord = composingWord.name;
        this.isAlreadyOpenedWord = true;
        this.cdr.detectChanges();
        setTimeout(function () {
            _this.isAlreadyOpenedWord = false;
            _this.cdr.detectChanges();
        }, 800);
    };
    WordPage.prototype.manageComposeWordTime = function () {
        this.endComposeWordTime = new Date().getTime();
        if (this.endComposeWordTime - this.startComposeWordTime <= 500) {
            this.startComposeWordTime = null;
            this.achievementsService.manageAchievementByIndex(0);
        }
    };
    WordPage.prototype.manageAchievements = function () {
        if (!this.isLongestWordAchievementEarned && this.openedWord.length === 9) {
            this.achievementsService.manageAchievementByIndex(1);
        }
        if (!this.isWordComposedAchievementEarned && this.word.totalComposingWords === this.word.openedComposingWords) {
            this.achievementsService.manageAchievementByIndex(2);
        }
        if (!this.isCategoryComposedAchievementEarned && this.categoryInfo.totalComposingWordsCount === this.categoryInfo.openedComposingWordsCount) {
            this.achievementsService.manageAchievementByIndex(5);
        }
    };
    WordPage.prototype.manageCoins = function () {
        var _this = this;
        this.utilsService.playSound('success');
        this.earnedCoins = this.openedWord.length;
        this.isCoinsEarned = true;
        this.utilsService.setCoins(this.coins + this.earnedCoins);
        this.storeService.addCoins(this.earnedCoins);
        setTimeout(function () {
            _this.isCoinsEarned = false;
            _this.cdr.detectChanges();
        }, 1000);
    };
    WordPage.prototype.openComposedWord = function (composedWord) {
        var _this = this;
        this.dbService.executeQuery(__WEBPACK_IMPORTED_MODULE_2__services_db__["a" /* DBQueries */].OPEN_COMPOSING_WORD_BY_ID, function (tr, rs) {
            composedWord.isOpened = 1;
            _this.storeService.allOpenedWordsCount++;
            _this.cdr.detectChanges();
            if (!_this.isUniqueComposedWordsAchievementEarned) {
                _this.manageUniqueComposedByUserWords();
            }
        }, [1, composedWord.id]);
    };
    WordPage.prototype.manageUniqueComposedByUserWords = function () {
        var _this = this;
        this.dbService.executeQuery(__WEBPACK_IMPORTED_MODULE_2__services_db__["a" /* DBQueries */].GET_UNIQUE_COMPOSED_BY_USER_WORDS, function (tr, rs) {
            _this.uniqueComposedByUserWords = rs.rows.item(0);
            if (_this.uniqueComposedByUserWords.count === 700) {
                _this.achievementsService.manageAchievementByIndex(6);
            }
        });
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["_8" /* ViewChild */])('headerTag'),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["t" /* ElementRef */])
    ], WordPage.prototype, "headerTag", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["_8" /* ViewChild */])('scrollableTag'),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["t" /* ElementRef */])
    ], WordPage.prototype, "scrollableTag", void 0);
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["_8" /* ViewChild */])('composedWord'),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_0__angular_core__["t" /* ElementRef */])
    ], WordPage.prototype, "composedWordEl", void 0);
    WordPage = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["m" /* Component */])({
            selector: 'page-word',template:/*ion-inline-start:"D:\GIT\wordsInAWord\src\pages\word\word.html"*/'<div class="add-coins" *ngIf="isCoinsEarned">\n  <span>+{{earnedCoins}}</span> \n  <img class="coins-image" src="assets/img/gold_coins.png">\n  <div class="opened-word">«{{openedWord}}»</div>\n</div>\n\n<div class="already-opened-word" *ngIf="isAlreadyOpenedWord">\n  «{{alreadyOpenedWord}}»\n  <div>вже складено</div>\n</div>\n\n<ion-header>\n  <ion-navbar>\n    <button ion-button menuToggle>\n      <ion-icon name="menu"></ion-icon>\n    </button>\n    <ion-title>СКЛАДАТИ СЛОВА</ion-title>\n  </ion-navbar>\n  <div class="border-decoration"></div>\n</ion-header>\n\n<ion-content class="word-content">\n  <div #headerTag ion-fixed>\n    <div class="word-header-content" [ngClass]="{\'not-loaded\': !isDataLoaded, \'loaded\': isDataLoaded}">\n      <div class="word-name-buttons-block" (click)="onLettersClick($event)">\n        <button *ngFor="let letter of letters" class="word-name-button">\n          {{letter}}\n          </button>\n      </div>\n\n      <div class="composed-word-controls">\n        <button class="clear-composed-word" (click)="onClearClick()">\n          <ion-icon name="trash"></ion-icon>\n        </button>\n        <input #composedWord class="composed-word" disabled="disabled">\n        <button class="remove-letter-in-composed-word" (click)="onLastLetterRemoveClick()">\n          <ion-icon name="backspace"></ion-icon>\n        </button>\n      </div>\n\n      <div class="opened-words-description">\n        <p *ngIf="word && word.composingWords">\n          <span>Складено {{openedWordsCount}} з {{word.composingWords.length}} {{endOfOpenedWordsDescription}}</span>\n        </p>\n      </div>\n    </div>\n    <div class="border-decoration"></div>\n  </div>\n\n  <div #scrollableTag class="composing-words">\n    <ion-list *ngIf="word.composingWords"\n              class="composing-words-list"\n              [ngClass]="{\'not-loaded\': !isDataLoaded, \'loaded\': isDataLoaded}"\n              (click)="onComposingWordsClick($event)">\n      <ion-item *ngFor="let composingWord of word.composingWords; let i = index; trackBy: trackComposingWord"\n                class="composing-word"\n                [attr.data-index]="i">\n        {{composingWord.isOpened ? composingWord.name : displayNotOpenedWord(composingWord.name.length)}}\n      </ion-item>\n    </ion-list>\n  </div>\n</ion-content>\n\n<ion-footer class="footer">\n  <div class="border-decoration"></div>\n  <ion-toolbar>\n    <ion-title>\n      <span class="coins-info">\n        <span class="coins-button">{{coins}}</span>\n        <img class="coins-image" src="assets/img/gold_coins.png">\n      </span>\n    </ion-title>\n  </ion-toolbar>\n</ion-footer>\n'/*ion-inline-end:"D:\GIT\wordsInAWord\src\pages\word\word.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["f" /* NavController */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["g" /* NavParams */],
            __WEBPACK_IMPORTED_MODULE_0__angular_core__["t" /* ElementRef */],
            __WEBPACK_IMPORTED_MODULE_0__angular_core__["j" /* ChangeDetectorRef */],
            __WEBPACK_IMPORTED_MODULE_2__services_db__["b" /* DBService */],
            __WEBPACK_IMPORTED_MODULE_3__services_store__["a" /* StoreService */],
            __WEBPACK_IMPORTED_MODULE_4__services_achievements__["a" /* AchievementsService */],
            __WEBPACK_IMPORTED_MODULE_5__services_utils__["a" /* UtilsService */]])
    ], WordPage);
    return WordPage;
}());

//# sourceMappingURL=word.js.map

/***/ }),

/***/ 202:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ComposingWordPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(29);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__services_db__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__services_store__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__services_achievements__ = __webpack_require__(38);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__services_utils__ = __webpack_require__(32);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};






var ComposingWordPage = /** @class */ (function () {
    function ComposingWordPage(cdr, navParams, dbService, storeService, achievementsService, utilsService) {
        this.cdr = cdr;
        this.navParams = navParams;
        this.dbService = dbService;
        this.storeService = storeService;
        this.achievementsService = achievementsService;
        this.utilsService = utilsService;
        this.promptPrice = 15;
        this.letterPrice = 10;
        this.isNotEnoughCoins = false;
        this.isDataLoaded = false;
        this.composingWord = this.navParams.get('composingWord');
        this.word = this.navParams.get('word');
        this.categoryInfo = this.navParams.get('categoryInfo');
        this.setCoins();
        this.manageData();
    }
    Object.defineProperty(ComposingWordPage.prototype, "nonOpenWord", {
        get: function () {
            var s = '-';
            for (var i = 0; i < this.composingWord.name.length - 1; i++) {
                s += ' -';
            }
            return s;
        },
        enumerable: true,
        configurable: true
    });
    ComposingWordPage.prototype.displayDescription = function () {
        if (this.composingWord.isDescriptionOpened && this.composingWord.description) {
            return this.composingWord.description.replace(/ ([2-9]). /g, '<br>$1. ');
        }
        else
            return '';
    };
    ComposingWordPage.prototype.openDescription = function () {
        var _this = this;
        if (this.isEnoughCoinsForPrompt()) {
            this.utilsService.playSound('purchase');
            this.dbService.executeQuery(__WEBPACK_IMPORTED_MODULE_2__services_db__["a" /* DBQueries */].OPEN_COMPOSING_WORD_DESC_BY_ID, function (tr, rs) {
                _this.composingWord.isDescriptionOpened = true;
                _this.utilsService.setCoins(_this.coins - _this.promptPrice);
                _this.storeService.addCoins(-_this.promptPrice);
                _this.cdr.detectChanges();
            }, [this.composingWord.id]);
        }
        else {
            this.utilsService.playSound('error');
            this.isNotEnoughCoins = true;
            this.hideNotEnoughCoinsMessage();
        }
    };
    ComposingWordPage.prototype.openWord = function () {
        var _this = this;
        if (this.isEnoughCoinsForOpeningWord()) {
            this.utilsService.playSound('purchase');
            this.dbService.executeQuery(__WEBPACK_IMPORTED_MODULE_2__services_db__["a" /* DBQueries */].OPEN_COMPOSING_WORD_BY_ID, function (tr, rs) {
                _this.composingWord.isOpened = true;
                _this.composingWord.isDescriptionOpened = true;
                _this.storeService.allOpenedWordsCount++;
                _this.word.openedComposingWords++;
                _this.categoryInfo.openedComposingWordsCount++;
                _this.utilsService.setCoins(_this.coins - _this.price);
                _this.storeService.addCoins(-_this.price);
                _this.cdr.detectChanges();
                _this.manageAchievements();
            }, [0, this.composingWord.id]);
        }
        else {
            this.utilsService.playSound('error');
            this.isNotEnoughCoins = true;
            this.hideNotEnoughCoinsMessage();
        }
    };
    ComposingWordPage.prototype.setCoins = function () {
        var _this = this;
        this.storeService.getCoins().subscribe(function (amount) {
            _this.coins = amount;
        });
    };
    ComposingWordPage.prototype.manageData = function () {
        var _this = this;
        this.dbService.executeQuery(__WEBPACK_IMPORTED_MODULE_2__services_db__["a" /* DBQueries */].GET_COMPOSING_WORD_BY_ID, function (tr, rs) {
            var data = rs.rows.item(0);
            _this.composingWord.isDescriptionOpened = data.isDescriptionOpened;
            _this.composingWord.description = data.description;
            _this.price = _this.composingWord.name.length * _this.letterPrice;
            _this.isDataLoaded = true;
        }, [this.composingWord.id]);
    };
    ComposingWordPage.prototype.isEnoughCoinsForOpeningWord = function () {
        return (this.coins >= this.price);
    };
    ComposingWordPage.prototype.isEnoughCoinsForPrompt = function () {
        return (this.coins >= this.promptPrice);
    };
    ComposingWordPage.prototype.hideNotEnoughCoinsMessage = function () {
        var _this = this;
        setTimeout(function () {
            _this.isNotEnoughCoins = false;
        }, 800);
    };
    ComposingWordPage.prototype.manageAchievements = function () {
        var achievements = this.achievementsService.achievements;
        if (!achievements[2].isEarned && this.word.totalComposingWords === this.word.openedComposingWords) {
            this.achievementsService.manageAchievementByIndex(2);
        }
        if (!achievements[5].isEarned && this.categoryInfo.totalComposingWordsCount === this.categoryInfo.openedComposingWordsCount) {
            this.achievementsService.manageAchievementByIndex(5);
        }
    };
    ComposingWordPage = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["m" /* Component */])({
            selector: 'page-composing-word',template:/*ion-inline-start:"D:\GIT\wordsInAWord\src\pages\composing-word\composing-word.html"*/'<div class="not-enough-coins" *ngIf="isNotEnoughCoins">Не вистачає монет</div>\n\n<ion-header>\n  <ion-navbar>\n    <button ion-button menuToggle>\n      <ion-icon name="menu"></ion-icon>\n    </button>\n    <ion-title>СЛОВО</ion-title>\n  </ion-navbar>\n  <div class="border-decoration"></div>\n</ion-header>\n\n<ion-content class="composing-word-info">\n  <div class="composing-word-info-content" [ngClass]="{\'not-loaded\': !isDataLoaded, \'loaded\': isDataLoaded}">\n    <h1>{{composingWord.isOpened ? composingWord.name : nonOpenWord}}</h1>\n    <button *ngIf="!composingWord.isDescriptionOpened"\n            class="prompt-button"\n            (click)="openDescription()">\n      Підказати\n    </button>\n    <p *ngIf="!composingWord.isDescriptionOpened" class="button-info" >\n      Підказка коштує {{promptPrice}} монет\n    </p>\n  \n    <p class="composing-word-description" [innerHtml]="displayDescription()"></p>\n    <button *ngIf="!composingWord.isOpened"\n            class="open-word-button"\n            (click)="openWord()">\n      Відкрити\n    </button>\n    <p *ngIf="!composingWord.isOpened" class="button-info" >\n      Відкриття слова коштує {{price}} монет\n    </p>\n  </div>\n</ion-content>\n\n<ion-footer class="footer">\n  <div class="border-decoration"></div>\n  <ion-toolbar>\n    <ion-title>\n      <span class="coins-info">\n        <span class="coins-button">{{coins}}</span>\n        <img class="coins-image" src="assets/img/gold_coins.png">\n      </span>\n    </ion-title>\n  </ion-toolbar>\n</ion-footer>\n'/*ion-inline-end:"D:\GIT\wordsInAWord\src\pages\composing-word\composing-word.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["j" /* ChangeDetectorRef */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["g" /* NavParams */],
            __WEBPACK_IMPORTED_MODULE_2__services_db__["b" /* DBService */],
            __WEBPACK_IMPORTED_MODULE_3__services_store__["a" /* StoreService */],
            __WEBPACK_IMPORTED_MODULE_4__services_achievements__["a" /* AchievementsService */],
            __WEBPACK_IMPORTED_MODULE_5__services_utils__["a" /* UtilsService */]])
    ], ComposingWordPage);
    return ComposingWordPage;
}());

//# sourceMappingURL=composing-word.js.map

/***/ }),

/***/ 203:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SettingsPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_animations__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__services_db__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__services_store__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__services_utils__ = __webpack_require__(32);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





var SettingsPage = /** @class */ (function () {
    function SettingsPage(dbService, storeService, utilsService) {
        this.dbService = dbService;
        this.storeService = storeService;
        this.utilsService = utilsService;
        this.themes = [
            { code: 'winter', name: 'Зимова казка' },
            { code: 'flowers', name: 'Весняні квіти' },
            { code: 'vintage', name: 'Вінтаж' },
            { code: 'space', name: 'Космос' },
            { code: 'seaside', name: 'Пляж' }
        ];
        this.soundsMode = this.storeService.isSoundOn;
        this.selectedTheme = this.storeService.theme;
    }
    SettingsPage.prototype.onSoundsModeChange = function () {
        var _this = this;
        this.dbService.executeQuery(__WEBPACK_IMPORTED_MODULE_2__services_db__["a" /* DBQueries */].SET_SOUNDS, function () {
            _this.storeService.isSoundOn = _this.soundsMode;
        }, [this.soundsMode ? 1 : 0]);
    };
    SettingsPage.prototype.onThemeChange = function () {
        var _this = this;
        this.dbService.executeQuery(__WEBPACK_IMPORTED_MODULE_2__services_db__["a" /* DBQueries */].SET_THEME, function () {
            _this.storeService.theme = _this.selectedTheme;
            _this.utilsService.changeTheme(_this.selectedTheme);
        }, [this.selectedTheme]);
    };
    SettingsPage = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["m" /* Component */])({
            selector: 'page-settings',template:/*ion-inline-start:"D:\GIT\wordsInAWord\src\pages\settings\settings.html"*/'<ion-header>\n  <ion-navbar>\n    <button ion-button menuToggle>\n      <ion-icon name="menu"></ion-icon>\n    </button>\n    <ion-title>НАЛАШТУВАННЯ</ion-title>\n  </ion-navbar>\n  <div class="border-decoration"></div>\n</ion-header>\n\n<ion-content class="settings" [@easeIn]>\n  <ion-item class="sounds-mode">\n    <ion-label>Звуки</ion-label>\n    <ion-toggle [(ngModel)]="soundsMode" (ionChange)="onSoundsModeChange()"></ion-toggle>\n  </ion-item>\n\n  <h3>Тема</h3>\n  <ion-list radio-group (ionChange)="onThemeChange()" [(ngModel)]="selectedTheme">\n    <ion-item *ngFor="let theme of themes" class="theme">\n      <ion-label>{{theme.name}}</ion-label>\n      <ion-radio slot="end" [value]="theme.code"></ion-radio>\n    </ion-item>\n  </ion-list>\n</ion-content>\n\n<ion-footer class="footer">\n  <div class="border-decoration"></div>\n  <ion-toolbar>\n  </ion-toolbar>\n</ion-footer>\n'/*ion-inline-end:"D:\GIT\wordsInAWord\src\pages\settings\settings.html"*/,
            animations: [
                Object(__WEBPACK_IMPORTED_MODULE_1__angular_animations__["i" /* trigger */])('easeIn', [
                    Object(__WEBPACK_IMPORTED_MODULE_1__angular_animations__["h" /* transition */])(':enter', [
                        Object(__WEBPACK_IMPORTED_MODULE_1__angular_animations__["g" /* style */])({ opacity: 0 }),
                        Object(__WEBPACK_IMPORTED_MODULE_1__angular_animations__["e" /* animate */])('400ms ease-in', Object(__WEBPACK_IMPORTED_MODULE_1__angular_animations__["g" /* style */])({ opacity: 1 }))
                    ]),
                    Object(__WEBPACK_IMPORTED_MODULE_1__angular_animations__["h" /* transition */])(':leave', [
                        Object(__WEBPACK_IMPORTED_MODULE_1__angular_animations__["e" /* animate */])('400ms ease-in', Object(__WEBPACK_IMPORTED_MODULE_1__angular_animations__["g" /* style */])({ opacity: 0 }))
                    ])
                ])
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_2__services_db__["b" /* DBService */],
            __WEBPACK_IMPORTED_MODULE_3__services_store__["a" /* StoreService */],
            __WEBPACK_IMPORTED_MODULE_4__services_utils__["a" /* UtilsService */]])
    ], SettingsPage);
    return SettingsPage;
}());

//# sourceMappingURL=settings.js.map

/***/ }),

/***/ 204:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return InfoPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_animations__ = __webpack_require__(36);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};


var InfoPage = /** @class */ (function () {
    function InfoPage() {
    }
    InfoPage = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["m" /* Component */])({
            selector: 'page-info',template:/*ion-inline-start:"D:\GIT\wordsInAWord\src\pages\info\info.html"*/'<ion-header>\n  <ion-navbar>\n    <button ion-button menuToggle>\n      <ion-icon name="menu"></ion-icon>\n    </button>\n    <ion-title>ЯК ГРАТИ</ion-title>\n  </ion-navbar>\n  <div class="border-decoration"></div>\n</ion-header>\n\n<ion-content class="game-info" [@easeIn]>\n  <div class="game-info-text">\n    <p>Вам потрібно складати слова із заданих слів-завдань, які об\'єднані в різноманітні категорії за тематикою \n      (наприклад, «Україна»). Кожна категорія містить по 5 слів-завдань. На початку гри відкрита лише одна категорія. Для того, щоб відкрити наступну, потрібно скласти половину можливих слів із попередньої. Необхідну кількість слів \n      Ви побачите під назвою категорії.</p>\n    <p>Слова, які можна скласти, є іменниками в називному відмінку однини або, як виняток, і множини, якщо вони мають \n      різні значення або вживаються лише в множині. Власні назви, абревіатури та діалектні, розмовні, пестливі, збільшувані, лайливі, зневажливі, фамільярні іменники не зараховуються. Також гра містить дуже мало застарілих та рідковживаних слів.</p>\n    <p>За кожне складене слово Ви отримуєте монети. Кількість отриманих монет залежить від кількості літер у слові \n      (наприклад, за слово «кран» - 4 монети). Монети дозволяють Вам відкривати нерозгадані слова чи підказки до них. Для цього натисніть на нерозгадане слово і скористайтеся відповідними кнопками:</p>\n    <ul>\n      <li><p>«Підказати» - відкрити тлумачення слова - вартість 15 монет</p></li>\n      <li><p>«Відкрити» - відкрити слово і його тлумачення - вартість залежить від кількості літер у слові (10 монет \n        за кожну літеру)</p></li>\n    </ul>\n    <p>Також гра містить досягнення. Їх перелік з розміром винагороди та загальний прогрес складання слів можна \n      побачити, натиснувши на пункт «Досягнення» у головному меню.</p>\n    <p>Крім цього, гра підтримує різні теми дизайну. Натисніть на пункт «Налаштування» у головному меню і\n      оберіть тему, яка Вам подобається. Також на сторінці налаштувань можна вимкнути/увімкнути звуки.</p>\n    <p>У разі побажань (наприклад, чогось не вистачає) чи зауважень (наприклад, існуюче слово не приймається грою)\n      звертайтесь на поштову скриньку words.in.a.word@gmail.com</p>\n    <p>Дякуємо, що обрали нашу гру!</p>\n  </div>\n</ion-content>\n\n<ion-footer class="footer">\n  <div class="border-decoration"></div>\n  <ion-toolbar>\n  </ion-toolbar>\n</ion-footer>\n'/*ion-inline-end:"D:\GIT\wordsInAWord\src\pages\info\info.html"*/,
            animations: [
                Object(__WEBPACK_IMPORTED_MODULE_1__angular_animations__["i" /* trigger */])('easeIn', [
                    Object(__WEBPACK_IMPORTED_MODULE_1__angular_animations__["h" /* transition */])(':enter', [
                        Object(__WEBPACK_IMPORTED_MODULE_1__angular_animations__["g" /* style */])({ opacity: 0 }),
                        Object(__WEBPACK_IMPORTED_MODULE_1__angular_animations__["e" /* animate */])('400ms ease-in', Object(__WEBPACK_IMPORTED_MODULE_1__angular_animations__["g" /* style */])({ opacity: 1 }))
                    ]),
                    Object(__WEBPACK_IMPORTED_MODULE_1__angular_animations__["h" /* transition */])(':leave', [
                        Object(__WEBPACK_IMPORTED_MODULE_1__angular_animations__["e" /* animate */])('400ms ease-in', Object(__WEBPACK_IMPORTED_MODULE_1__angular_animations__["g" /* style */])({ opacity: 0 }))
                    ])
                ])
            ]
        })
    ], InfoPage);
    return InfoPage;
}());

//# sourceMappingURL=info.js.map

/***/ }),

/***/ 205:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AchievementsPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_animations__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__services_achievements__ = __webpack_require__(38);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__services_db__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__services_store__ = __webpack_require__(18);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





var AchievementsPage = /** @class */ (function () {
    function AchievementsPage(cdr, achievementsService, dbService, storeService) {
        this.cdr = cdr;
        this.achievementsService = achievementsService;
        this.dbService = dbService;
        this.storeService = storeService;
        this.achievements = this.achievementsService.achievements;
        this.setUniqueComposedByUserWords();
    }
    Object.defineProperty(AchievementsPage.prototype, "openedWordsPercentage", {
        get: function () {
            return (this.storeService.allOpenedWordsCount * 100 / this.storeService.totalComposingWordsCount).toFixed(2);
        },
        enumerable: true,
        configurable: true
    });
    ;
    AchievementsPage.prototype.setUniqueComposedByUserWords = function () {
        var _this = this;
        this.dbService.executeQuery(__WEBPACK_IMPORTED_MODULE_3__services_db__["a" /* DBQueries */].GET_UNIQUE_COMPOSED_BY_USER_WORDS, function (tr, rs) {
            _this.uniqueComposedByUserWords = rs.rows.item(0);
            _this.cdr.detectChanges();
        });
    };
    AchievementsPage = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["m" /* Component */])({
            selector: 'page-achievements',template:/*ion-inline-start:"D:\GIT\wordsInAWord\src\pages\achievements\achievements.html"*/'<ion-header>\n  <ion-navbar>\n    <button ion-button menuToggle>\n      <ion-icon name="menu"></ion-icon>\n    </button>\n    <ion-title>ДОСЯГНЕННЯ</ion-title>\n  </ion-navbar>\n  <div class="border-decoration"></div>\n</ion-header>\n\n<ion-content class="achievements" [@easeIn]>\n  <div class="list">\n    <div class="item">\n      <img class="achievement-icon" src="assets/img/achievements/0.png">\n      <div class="achievement-details">\n        <h2>Прогрес</h2>\n        <h3>Відсоток складених слів від загальної кількості</h3>\n        <div class="progress">\n          <div class="progress-bar">\n            <div class="progress-indicator"\n                 [ngStyle]="{\'width\': openedWordsPercentage + \'%\'}">\n            </div>\n          </div>\n          <p>{{openedWordsPercentage}}%</p>\n        </div>\n      </div>\n    </div>\n\n    <div *ngFor="let achievement of achievements"\n         class="item"\n         [ngStyle]="{\'opacity\': achievement.isEarned ? 1 : 0.5}">\n      <img class="achievement-icon" src="assets/img/achievements/{{achievement.id}}.png">\n      <div class="achievement-details">\n        <h2><ion-icon name="checkmark" *ngIf="achievement.isEarned"> </ion-icon>{{achievement.name}}</h2>\n        <h3>{{achievement.description}}</h3>\n        <h3>Винагорода: {{achievement.reward}} монет</h3>\n        <h3 *ngIf="achievement.id==7 && achievement.isEarned==0 && uniqueComposedByUserWords">Прогрес: {{uniqueComposedByUserWords.count}}</h3>\n      </div>\n    </div>\n  </div>\n</ion-content>\n\n<ion-footer class="footer">\n  <div class="border-decoration"></div>\n  <ion-toolbar>\n  </ion-toolbar>\n</ion-footer>\n'/*ion-inline-end:"D:\GIT\wordsInAWord\src\pages\achievements\achievements.html"*/,
            animations: [
                Object(__WEBPACK_IMPORTED_MODULE_1__angular_animations__["i" /* trigger */])('easeIn', [
                    Object(__WEBPACK_IMPORTED_MODULE_1__angular_animations__["h" /* transition */])(':enter', [
                        Object(__WEBPACK_IMPORTED_MODULE_1__angular_animations__["g" /* style */])({ opacity: 0 }),
                        Object(__WEBPACK_IMPORTED_MODULE_1__angular_animations__["e" /* animate */])('400ms ease-in', Object(__WEBPACK_IMPORTED_MODULE_1__angular_animations__["g" /* style */])({ opacity: 1 }))
                    ]),
                    Object(__WEBPACK_IMPORTED_MODULE_1__angular_animations__["h" /* transition */])(':leave', [
                        Object(__WEBPACK_IMPORTED_MODULE_1__angular_animations__["e" /* animate */])('400ms ease-in', Object(__WEBPACK_IMPORTED_MODULE_1__angular_animations__["g" /* style */])({ opacity: 0 }))
                    ])
                ])
            ]
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_0__angular_core__["j" /* ChangeDetectorRef */],
            __WEBPACK_IMPORTED_MODULE_2__services_achievements__["a" /* AchievementsService */],
            __WEBPACK_IMPORTED_MODULE_3__services_db__["b" /* DBService */],
            __WEBPACK_IMPORTED_MODULE_4__services_store__["a" /* StoreService */]])
    ], AchievementsPage);
    return AchievementsPage;
}());

//# sourceMappingURL=achievements.js.map

/***/ }),

/***/ 206:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_platform_browser_dynamic__ = __webpack_require__(207);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__app_module__ = __webpack_require__(228);


Object(__WEBPACK_IMPORTED_MODULE_0__angular_platform_browser_dynamic__["a" /* platformBrowserDynamic */])().bootstrapModule(__WEBPACK_IMPORTED_MODULE_1__app_module__["a" /* AppModule */]);
//# sourceMappingURL=main.js.map

/***/ }),

/***/ 21:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return DBQueries; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return DBService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(29);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__store__ = __webpack_require__(18);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};



var DBQueries;
(function (DBQueries) {
    DBQueries["GET_ACHIEVEMENTS"] = "getAchievements";
    DBQueries["GET_CATEGORIES"] = "getCategories";
    DBQueries["GET_GATEGORY_INFO_BY_ID"] = "getCategoryInfoById";
    DBQueries["GET_COINS"] = "getCoins";
    DBQueries["GET_COMPOSING_WORDS"] = "getComposingWords";
    DBQueries["GET_COMPOSING_WORD_BY_ID"] = "getComposingWordById";
    DBQueries["GET_SETTINGS"] = "getSettings";
    DBQueries["GET_UNIQUE_COMPOSED_BY_USER_WORDS"] = "getUniqueComposedByUserWords";
    DBQueries["GET_WORDS"] = "getWords";
    DBQueries["GET_WORD_DESC_BY_NAME"] = "getWordDescriptionByName";
    DBQueries["OPEN_ACHIEVEMENT_BY_INDEX"] = "openAchievementByIndex";
    DBQueries["OPEN_CATEGORY_BY_ID"] = "openCategoryById";
    DBQueries["OPEN_COMPOSING_WORD_BY_ID"] = "openComposingWordById";
    DBQueries["OPEN_COMPOSING_WORD_DESC_BY_ID"] = "openComposingWordDescriptionById";
    DBQueries["SET_COINS"] = "setCoins";
    DBQueries["SET_SOUNDS"] = "setSounds";
    DBQueries["SET_THEME"] = "setTheme";
})(DBQueries || (DBQueries = {}));
var DBService = /** @class */ (function () {
    function DBService(platform, storeService) {
        this.platform = platform;
        this.storeService = storeService;
    }
    DBService.prototype.initDatabase = function () {
        var _this = this;
        if (this.platform.is('android')) {
            window.sqlitePlugin.openDatabase({
                name: 'wordsInAWord.db',
                location: 'default',
                createFromLocation: 1
            }, function (db) {
                _this.db = db;
                _this.storeService.openDB(true);
            }, function (err) {
                _this.storeService.openDB(false);
            });
        }
        else {
            this.db = window.openDatabase('wordsInAWord.db', '1', 'words db', 256 * 256 * 100);
            this.storeService.openDB(true);
        }
    };
    DBService.prototype.executeQuery = function (name, callbackFn, args) {
        if (args === void 0) { args = []; }
        this.db.transaction(function (tr) {
            tr.executeSql(queries[name], args, callbackFn);
        });
    };
    DBService.prototype.updateTestDB = function () {
        //const query = "CREATE TABLE categories ( id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT UNIQUE, name TEXT NOT NULL UNIQUE, isOpened INTEGER NOT NULL DEFAULT 0 )"
        //const query = "CREATE TABLE composing_words ( id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT UNIQUE, name TEXT NOT NULL, isOpened INTEGER NOT NULL DEFAULT 0, isComposedByUser INTEGER NOT NULL DEFAULT 0, isDescriptionOpened INTEGER NOT NULL DEFAULT 0, wordId INTEGER NOT NULL, FOREIGN KEY(wordId) REFERENCES words(id) )"
        //const query = "CREATE TABLE words ( id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT UNIQUE, name TEXT NOT NULL UNIQUE, categoryId INTEGER NOT NULL, FOREIGN KEY(categoryId) REFERENCES categories(id) )"
        //const query = "CREATE TABLE words_descriptions (id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT UNIQUE, name TEXT NOT NULL UNIQUE, description TEXT)"
        //const query = "create table achievements(id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT UNIQUE, name TEXT NOT NULL, description TEXT NOT NULL, isEarned INTEGER NOT NULL DEFAULT 0, reward INTEGER NOT NULL DEFAULT 0)"
        //const query = "create table user_settings(coins integer not null, sounds integer not null, theme text not null, data_version integer)"
        //const query = "INSERT INTO categories VALUES (1, 'Україна', 1), (2, 'Сила природи',0), (3, 'Дерева', 0), (4, 'Архітектура', 0), (5, 'Посуд', 0)"
        //const query = "insert into words(name, categoryId) values ('вишиванка', 1), ('тризуб', 1), ('українка', 1), ('чорнозем', 1), ('барвінок', 1), ('листопад', 2), ('веселка', 2), ('землетрус', 2), ('ураган', 2), ('блискавка', 2)";
        //const query = "insert into words(name, categoryId) values ('горобина', 3), ('черемха', 3), ('модрина', 3), ('жакаранда', 3), ('евкаліпт', 3), ('креслення', 4), ('барельєф', 4), ('колонада', 4), ('будівництво', 4), ('архітектор', 4)";
        //const query = "insert into composing_words(name, wordId) values ('аїр', 1), ('акр', 1), ('анкер', 1), ('ар', 1)"
        //const query = "insert into composing_words(name, wordId) values ('зерно', 2), ('зеро', 2), ('мезон', 2), ('мер', 2), ('меч', 2), ('мор', 2), ('море', 2), ('мороз', 2)"
        //const query = "insert into composing_words (name, wordId) values ('акин', 4), ('вика', 4), ('вина', 4), ('вишивка', 4), ('вишина', 4)";
        //const query = "insert into composing_words (name, wordId) values ('вишка', 4), ('вишник', 4), ('вшивка', 4), ('кава', 4), ('канва', 4)";
        //const query = "insert into composing_words (name, wordId) values ('абак', 5), ('абат', 5), ('акант', 5), ('акин', 5), ('акт', 5)";
        //const query = "insert into composing_words (name, wordId) values ('ангоб', 6), ('ар', 6), ('аргон', 6), ('багно', 6), ('багор', 6)";
        //const query = "insert into words_descriptions (name) values ('аїр'), ('акр'), ('анкер'), ('ap'), ('зерно'), ('зеро'), ('мезон'), ('мер'), ('меч'), ('мор'), ('мороз')"
        //const query = "insert into words_descriptions (name) values ('акин'), ('вика'), ('вина'), ('вишивка'), ('вишина'), ('вишка'), ('вишник'), ('вшивка'), ('канва')"
        //const query = "insert into words_descriptions (name) values ('абат'), ('акант'), ('акт'), ('ангоб'), ('аргон'), ('багно'), ('багор')"
        //const query = "update words_descriptions set description = 'Одиниця виміру земельної площі в Англії і Північній Америці; дорівнює 4047 м2' where name = 'акр'"
        //const query = "insert into user_settings(coins, sounds, theme, data_version) values (0, 1, 'vintage', 1)"
        //const query = "update user_settings set coins = 0"
        //const query = "update composing_words set isOpened = 0, isDescriptionOpened = 0, isComposedByUser = 0";
        //const query = "update categories set isOpened = 0 where id = 2 or id = 3"
        //const query = "drop table words_descriptions"
        //const query = "insert into achievements(name, description, reward) values ('Блискавична швидкість', 'Складено слово швидше, ніж за півсекунди', 100), ('Розумник','Складено найдовше слово (не враховуються відкриті слова за монети)', 200), ('Маестро слова', 'Відкрито всі слова з одного слова, в тому числі за монети', 300)"
        //const query = "insert into achievements(name, description, reward) values ('Першовідкривач', 'Відкрито першу категорію', 350), ('На півшляху', 'Відкрито половину категорій слів', 700), ('Маестро категорії', 'Відкрито всі слова з однієї категорії, в тому числі за монети', 1000)"
        //const query = "insert into achievements(name, description, reward) values ('700 слів', 'Складено 700 унікальних слів (не враховуються відкриті слова за монети)', 2500)"
        //const query = "update achievements set isEarned = 0";
        //const query = "delete from composing_words where id > 464";
        //const query = "delete from words_descriptions where id > 59";
        //const query = "select count(id) from composing_words where name = 'ара'";
        // this.db.transaction(function (tr: any) {
        //   tr.executeSql(query, []);
        // });
    };
    DBService = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["A" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["h" /* Platform */],
            __WEBPACK_IMPORTED_MODULE_2__store__["a" /* StoreService */]])
    ], DBService);
    return DBService;
}());

var queries = (_a = {},
    _a[DBQueries.GET_ACHIEVEMENTS] = "SELECT * FROM achievements",
    _a[DBQueries.GET_CATEGORIES] = "SELECT id, name, isOpened FROM categories",
    _a[DBQueries.GET_GATEGORY_INFO_BY_ID] = "SELECT (SELECT COUNT(CW.id) FROM composing_words as CW " +
        "LEFT JOIN words as W ON CW.wordId = W.id " +
        "LEFT JOIN categories as C ON W.categoryId = C.id " +
        "WHERE C.id = ?) totalComposingWordsCount, " +
        "(SELECT COUNT(case CW.isOpened when 1 then 1 else null end) FROM composing_words as CW " +
        "LEFT JOIN words as W ON CW.wordId = W.id " +
        "LEFT JOIN categories as C ON W.categoryId = C.id " +
        "WHERE C.id = ?) openedComposingWordsCount",
    _a[DBQueries.GET_COINS] = "SELECT coins FROM user_settings",
    _a[DBQueries.GET_COMPOSING_WORDS] = "SELECT id, name, isOpened FROM composing_words WHERE wordId = ?",
    _a[DBQueries.GET_COMPOSING_WORD_BY_ID] = "SELECT CW.id, CW.name, CW.isOpened, CW.isDescriptionOpened, WD.description " +
        "FROM composing_words CW LEFT JOIN words_descriptions WD ON CW.name = WD.name " +
        "WHERE CW.id = ?",
    _a[DBQueries.GET_SETTINGS] = "SELECT sounds, theme FROM user_settings",
    _a[DBQueries.GET_UNIQUE_COMPOSED_BY_USER_WORDS] = "SELECT COUNT(DISTINCT name) count FROM composing_words WHERE isComposedByUser = 1",
    _a[DBQueries.GET_WORDS] = "SELECT W.id, W.name, W.categoryId, " +
        "(SELECT COUNT(id) FROM composing_words WHERE wordId = W.id) totalComposingWords, " +
        "(SELECT COUNT(case isOpened when 1 then 1 else null end) FROM composing_words WHERE wordId = W.id) openedComposingWords " +
        "FROM words as W",
    _a[DBQueries.GET_WORD_DESC_BY_NAME] = "SELECT * FROM words_descriptions WHERE name = ?",
    _a[DBQueries.OPEN_ACHIEVEMENT_BY_INDEX] = "UPDATE achievements SET isEarned = 1 WHERE id = ?",
    _a[DBQueries.OPEN_CATEGORY_BY_ID] = "UPDATE categories SET isOpened = 1 WHERE id = ?",
    _a[DBQueries.OPEN_COMPOSING_WORD_BY_ID] = "UPDATE composing_words SET isOpened = 1, isDescriptionOpened = 1, isComposedByUser = ? WHERE id=?",
    _a[DBQueries.OPEN_COMPOSING_WORD_DESC_BY_ID] = "UPDATE composing_words SET isDescriptionOpened = 1 WHERE id = ?",
    _a[DBQueries.SET_COINS] = "UPDATE user_settings SET coins = ?",
    _a[DBQueries.SET_SOUNDS] = "UPDATE user_settings SET sounds = ?",
    _a[DBQueries.SET_THEME] = "UPDATE user_settings SET theme = ?",
    _a);
var _a;
//# sourceMappingURL=db.js.map

/***/ }),

/***/ 228:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AppModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_platform_browser__ = __webpack_require__(28);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__angular_platform_browser_animations__ = __webpack_require__(229);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_ionic_angular__ = __webpack_require__(29);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__ionic_native_status_bar__ = __webpack_require__(197);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__ionic_native_splash_screen__ = __webpack_require__(199);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__ionic_native_native_audio__ = __webpack_require__(105);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__app_component__ = __webpack_require__(280);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__pages_home_home__ = __webpack_require__(200);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__pages_settings_settings__ = __webpack_require__(203);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__pages_word_word__ = __webpack_require__(201);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__pages_composing_word_composing_word__ = __webpack_require__(202);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__pages_info_info__ = __webpack_require__(204);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_13__pages_achievements_achievements__ = __webpack_require__(205);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_14__services_db__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_15__services_store__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_16__services_achievements__ = __webpack_require__(38);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_17__services_utils__ = __webpack_require__(32);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};


















var AppModule = /** @class */ (function () {
    function AppModule() {
    }
    AppModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_2__angular_core__["I" /* NgModule */])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_7__app_component__["a" /* MyApp */],
                __WEBPACK_IMPORTED_MODULE_8__pages_home_home__["a" /* HomePage */],
                __WEBPACK_IMPORTED_MODULE_10__pages_word_word__["a" /* WordPage */],
                __WEBPACK_IMPORTED_MODULE_11__pages_composing_word_composing_word__["a" /* ComposingWordPage */],
                __WEBPACK_IMPORTED_MODULE_9__pages_settings_settings__["a" /* SettingsPage */],
                __WEBPACK_IMPORTED_MODULE_12__pages_info_info__["a" /* InfoPage */],
                __WEBPACK_IMPORTED_MODULE_13__pages_achievements_achievements__["a" /* AchievementsPage */],
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_0__angular_platform_browser__["a" /* BrowserModule */],
                __WEBPACK_IMPORTED_MODULE_1__angular_platform_browser_animations__["a" /* BrowserAnimationsModule */],
                __WEBPACK_IMPORTED_MODULE_3_ionic_angular__["d" /* IonicModule */].forRoot(__WEBPACK_IMPORTED_MODULE_7__app_component__["a" /* MyApp */], {}, {
                    links: []
                }),
            ],
            bootstrap: [__WEBPACK_IMPORTED_MODULE_3_ionic_angular__["b" /* IonicApp */]],
            entryComponents: [
                __WEBPACK_IMPORTED_MODULE_7__app_component__["a" /* MyApp */],
                __WEBPACK_IMPORTED_MODULE_8__pages_home_home__["a" /* HomePage */],
                __WEBPACK_IMPORTED_MODULE_10__pages_word_word__["a" /* WordPage */],
                __WEBPACK_IMPORTED_MODULE_11__pages_composing_word_composing_word__["a" /* ComposingWordPage */],
                __WEBPACK_IMPORTED_MODULE_9__pages_settings_settings__["a" /* SettingsPage */],
                __WEBPACK_IMPORTED_MODULE_12__pages_info_info__["a" /* InfoPage */],
                __WEBPACK_IMPORTED_MODULE_13__pages_achievements_achievements__["a" /* AchievementsPage */],
            ],
            providers: [
                __WEBPACK_IMPORTED_MODULE_4__ionic_native_status_bar__["a" /* StatusBar */],
                __WEBPACK_IMPORTED_MODULE_5__ionic_native_splash_screen__["a" /* SplashScreen */],
                __WEBPACK_IMPORTED_MODULE_6__ionic_native_native_audio__["a" /* NativeAudio */],
                __WEBPACK_IMPORTED_MODULE_14__services_db__["b" /* DBService */],
                __WEBPACK_IMPORTED_MODULE_15__services_store__["a" /* StoreService */],
                __WEBPACK_IMPORTED_MODULE_16__services_achievements__["a" /* AchievementsService */],
                __WEBPACK_IMPORTED_MODULE_17__services_utils__["a" /* UtilsService */],
                { provide: __WEBPACK_IMPORTED_MODULE_2__angular_core__["u" /* ErrorHandler */], useClass: __WEBPACK_IMPORTED_MODULE_3_ionic_angular__["c" /* IonicErrorHandler */] }
            ]
        })
    ], AppModule);
    return AppModule;
}());

//# sourceMappingURL=app.module.js.map

/***/ }),

/***/ 280:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return MyApp; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(29);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ionic_native_status_bar__ = __webpack_require__(197);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__ionic_native_splash_screen__ = __webpack_require__(199);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__ionic_native_native_audio__ = __webpack_require__(105);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__services_db__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__services_store__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__services_achievements__ = __webpack_require__(38);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__services_utils__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__pages_home_home__ = __webpack_require__(200);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10__pages_settings_settings__ = __webpack_require__(203);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_11__pages_info_info__ = __webpack_require__(204);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_12__pages_achievements_achievements__ = __webpack_require__(205);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};













var MyApp = /** @class */ (function () {
    function MyApp(platform, statusBar, splashScreen, nativeAudio, dbService, storeService, achievementsService, utilsService) {
        this.platform = platform;
        this.statusBar = statusBar;
        this.splashScreen = splashScreen;
        this.nativeAudio = nativeAudio;
        this.dbService = dbService;
        this.storeService = storeService;
        this.achievementsService = achievementsService;
        this.utilsService = utilsService;
        this.rootPage = __WEBPACK_IMPORTED_MODULE_9__pages_home_home__["a" /* HomePage */];
        this.initializeApp();
        this.pages = [
            { title: 'Грати', component: __WEBPACK_IMPORTED_MODULE_9__pages_home_home__["a" /* HomePage */] },
            { title: 'Досягнення', component: __WEBPACK_IMPORTED_MODULE_12__pages_achievements_achievements__["a" /* AchievementsPage */] },
            { title: 'Налаштування', component: __WEBPACK_IMPORTED_MODULE_10__pages_settings_settings__["a" /* SettingsPage */] },
            { title: 'Як грати', component: __WEBPACK_IMPORTED_MODULE_11__pages_info_info__["a" /* InfoPage */] }
        ];
    }
    MyApp.prototype.initializeApp = function () {
        var _this = this;
        if (this.platform.is('android')) {
            document.addEventListener('deviceready', function () {
                // this.platform.ready().then(() => {
                //   this.statusBar.styleDefault();
                //   this.splashScreen.hide();
                // });
                _this.dbService.initDatabase();
                _this.manageData();
            });
        }
        else {
            this.dbService.initDatabase();
            this.manageData();
        }
    };
    MyApp.prototype.openPage = function (page) {
        // Reset the content nav to have just this page
        // we wouldn't want the back button to show in this scenario
        this.nav.setRoot(page.component);
    };
    MyApp.prototype.manageData = function () {
        var _this = this;
        this.storeService.isDBOpened().subscribe(function (isDBOpened) {
            if (isDBOpened) {
                _this.setSettings();
                _this.setCoins();
                _this.achievementsService.setAchievements();
                _this.preloadAudio();
            }
        });
    };
    MyApp.prototype.setSettings = function () {
        var _this = this;
        this.dbService.executeQuery(__WEBPACK_IMPORTED_MODULE_5__services_db__["a" /* DBQueries */].GET_SETTINGS, function (tr, rs) {
            var settings = rs.rows.item(0);
            _this.storeService.isSoundOn = !!settings.sounds;
            _this.storeService.theme = settings.theme;
            _this.utilsService.changeTheme(settings.theme);
        });
    };
    MyApp.prototype.setCoins = function () {
        var _this = this;
        this.dbService.executeQuery(__WEBPACK_IMPORTED_MODULE_5__services_db__["a" /* DBQueries */].GET_COINS, function (tr, rs) {
            _this.storeService.addCoins(rs.rows.item(0).coins);
        });
    };
    MyApp.prototype.preloadAudio = function () {
        if (this.platform.is('android')) {
            this.nativeAudio.preloadSimple('bonus', 'assets/sounds/bonus.wav');
            this.nativeAudio.preloadSimple('cancel', 'assets/sounds/cancel.wav');
            this.nativeAudio.preloadSimple('error', 'assets/sounds/error.wav');
            this.nativeAudio.preloadSimple('purchase', 'assets/sounds/purchase.wav');
            this.nativeAudio.preloadSimple('success', 'assets/sounds/success.mp3');
        }
    };
    __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["_8" /* ViewChild */])(__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["e" /* Nav */]),
        __metadata("design:type", __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["e" /* Nav */])
    ], MyApp.prototype, "nav", void 0);
    MyApp = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["m" /* Component */])({template:/*ion-inline-start:"D:\GIT\wordsInAWord\src\app\app.html"*/'<ion-menu [content]="content" type="overlay">\n  <ion-header>\n    <ion-toolbar>\n      <ion-title>Меню</ion-title>\n    </ion-toolbar>\n  </ion-header>\n\n  <ion-content>\n    <div class="border-decoration"></div>\n    <ion-list>\n      <button menuClose ion-item *ngFor="let page of pages" (click)="openPage(page)">\n        {{page.title}}\n      </button>\n    </ion-list>\n    <div class="border-decoration"></div>\n  </ion-content>\n</ion-menu>\n\n<!-- Disable swipe-to-go-back because it\'s poor UX to combine STGB with side menus -->\n<ion-nav [root]="rootPage" #content swipeBackEnabled="false"></ion-nav>'/*ion-inline-end:"D:\GIT\wordsInAWord\src\app\app.html"*/
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["h" /* Platform */],
            __WEBPACK_IMPORTED_MODULE_2__ionic_native_status_bar__["a" /* StatusBar */],
            __WEBPACK_IMPORTED_MODULE_3__ionic_native_splash_screen__["a" /* SplashScreen */],
            __WEBPACK_IMPORTED_MODULE_4__ionic_native_native_audio__["a" /* NativeAudio */],
            __WEBPACK_IMPORTED_MODULE_5__services_db__["b" /* DBService */],
            __WEBPACK_IMPORTED_MODULE_6__services_store__["a" /* StoreService */],
            __WEBPACK_IMPORTED_MODULE_7__services_achievements__["a" /* AchievementsService */],
            __WEBPACK_IMPORTED_MODULE_8__services_utils__["a" /* UtilsService */]])
    ], MyApp);
    return MyApp;
}());

//# sourceMappingURL=app.component.js.map

/***/ }),

/***/ 32:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return UtilsService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(29);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__ionic_native_native_audio__ = __webpack_require__(105);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__db__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__store__ = __webpack_require__(18);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};





var UtilsService = /** @class */ (function () {
    function UtilsService(platform, alertCtrl, nativeAudio, dbService, storeService) {
        this.platform = platform;
        this.alertCtrl = alertCtrl;
        this.nativeAudio = nativeAudio;
        this.dbService = dbService;
        this.storeService = storeService;
    }
    UtilsService.prototype.changeTheme = function (theme) {
        var styleElements = document.getElementsByTagName('link');
        for (var i = 0; i < styleElements.length; i++) {
            if (styleElements[i].title == 'theme') {
                styleElements[i].href = 'assets/css/' + theme + '.css';
            }
        }
    };
    UtilsService.prototype.playSound = function (sound) {
        if (this.platform.is('android') && this.storeService.isSoundOn) {
            this.nativeAudio.play(sound);
        }
    };
    UtilsService.prototype.setCoins = function (amount) {
        this.dbService.executeQuery(__WEBPACK_IMPORTED_MODULE_3__db__["a" /* DBQueries */].SET_COINS, function (tr, rs) { }, [amount]);
    };
    UtilsService.prototype.showAhievementAlert = function (name, reward) {
        var alertContent = '<p>Ви здобули винагороду</p>' +
            '<h5>' + reward + ' монет</h5>' +
            '<p>за досягнення</p>' +
            '<h4>«' + name + '»</h4>';
        var alert = this.alertCtrl.create({
            title: 'ВІТАННЯ!',
            subTitle: alertContent,
            buttons: ['OK'],
        });
        alert.present();
    };
    UtilsService.prototype.showOpenedCategoryAlert = function (name) {
        var alertContent = '<p>Ви відкрили нову категорію</p>' +
            '<h4>«' + name + '»</h4>';
        var alert = this.alertCtrl.create({
            title: 'ВІТАННЯ!',
            subTitle: alertContent,
            buttons: ['OK'],
        });
        alert.present();
    };
    UtilsService = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["A" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["h" /* Platform */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["a" /* AlertController */],
            __WEBPACK_IMPORTED_MODULE_2__ionic_native_native_audio__["a" /* NativeAudio */],
            __WEBPACK_IMPORTED_MODULE_3__db__["b" /* DBService */],
            __WEBPACK_IMPORTED_MODULE_4__store__["a" /* StoreService */]])
    ], UtilsService);
    return UtilsService;
}());

//# sourceMappingURL=utils.js.map

/***/ }),

/***/ 38:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return AchievementsService; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__db__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__store__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__utils__ = __webpack_require__(32);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};




var AchievementsService = /** @class */ (function () {
    function AchievementsService(databaseService, storeService, utilsService) {
        this.databaseService = databaseService;
        this.storeService = storeService;
        this.utilsService = utilsService;
        this._achievements = [];
    }
    Object.defineProperty(AchievementsService.prototype, "achievements", {
        get: function () {
            return this._achievements;
        },
        enumerable: true,
        configurable: true
    });
    AchievementsService.prototype.setAchievements = function () {
        var _this = this;
        this.databaseService.executeQuery(__WEBPACK_IMPORTED_MODULE_1__db__["a" /* DBQueries */].GET_ACHIEVEMENTS, function (tr, rs) {
            for (var i = 0; i < rs.rows.length; i++) {
                _this._achievements.push(rs.rows.item(i));
            }
        });
    };
    AchievementsService.prototype.manageAchievementByIndex = function (index) {
        var achievement = this._achievements[index];
        this.storeService.addCoins(achievement.reward);
        this.utilsService.playSound('bonus');
        this.utilsService.showAhievementAlert(achievement.name, achievement.reward);
        this.databaseService.executeQuery(__WEBPACK_IMPORTED_MODULE_1__db__["a" /* DBQueries */].OPEN_ACHIEVEMENT_BY_INDEX, function (tr, rs) {
            achievement.isEarned = 1;
        }, [index + 1]);
    };
    AchievementsService = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["A" /* Injectable */])(),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1__db__["b" /* DBService */],
            __WEBPACK_IMPORTED_MODULE_2__store__["a" /* StoreService */],
            __WEBPACK_IMPORTED_MODULE_3__utils__["a" /* UtilsService */]])
    ], AchievementsService);
    return AchievementsService;
}());

//# sourceMappingURL=achievements.js.map

/***/ })

},[206]);
//# sourceMappingURL=main.js.map